package holeg.ui.model;

import java.util.ArrayList;
import java.util.stream.Stream;

import holeg.model.Edge;
import holeg.model.GroupNode;

public class HolegModel {
	
	public enum FairnessModel{
		/**
		 * One Element of each HolonObject will be powered first, starting with the
		 * smallest Demand. If ale HolonObjects have an active Element, the
		 * simulation will try to fully supply as many HolonObjects as possible.
		 */
		MininumDemandFirst, 
		/**
		 * All HolonObjects will receive the same amount of energy.
		 */
		AllEqual
	}
    private FairnessModel fairnessModel = FairnessModel.MininumDemandFirst;    
    private GroupNode canvas = new GroupNode("Canvas");
    private ArrayList<Edge> edges = new ArrayList<>();

    public FairnessModel getFairnessModel() {
    	return fairnessModel;
    }
    public void setFairnessModel(FairnessModel fairnessModel) {
    	this.fairnessModel = fairnessModel;
    }
    
	public Stream<Edge> getEdges() {
		return edges.stream();
	}
	public void addEdge(Edge edge) {
		edges.add(edge);
	}
	public void removeEdge(Edge edge) {
		edges.remove(edge);
	}

	public GroupNode getCanvas() {
		return canvas;
	}
    
    

}
